tag @s add ml_dialogue
tag @s add ml_temp_dialogue
tag @a[tag=ml_targeting,limit=1,sort=nearest] add ml_editing
tag @a[tag=ml_interact,limit=1,sort=nearest] add ml_editing

summon minecraft:interaction ~ ~ ~ {Tags:[ml_dialogue_base,ml_dialogue_bottom,ml_deselected,ml_temp],Invulnerable:1b,width:1.25f,height:1f,response:1b}
summon minecraft:interaction ~ ~ ~ {Tags:[ml_dialogue_base,ml_dialogue_top,ml_deselected,ml_temp],Invulnerable:1b,width:1.25f,height:0.6f,response:1b}
summon minecraft:marker ~ ~ ~ {Tags:[ml_dialogue_base,ml_dialogue_data,ml_temp],Invulnerable:1b,data:{}}
summon minecraft:text_display ~ ~ ~ {Tags:[ml_dialogue_base,ml_dialogue_text,ml_temp],Invulnerable:1b,billboard:"center",text:'""'}
data modify entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data set from storage ml_dialogue:player data.dialogue.template
execute if entity @s[tag=ml_dialogue_init] run scoreboard players operation @e[tag=ml_dialogue_data,limit=1,sort=nearest] ml_badge = @a[tag=ml_editing,limit=1,sort=nearest] ml_badge

#ID the text bubble in order to reference it when not attached to NPC
function ml_dialogue:spawner/text_bubble
scoreboard players operation @e[tag=ml_dialogue_bubble,tag=ml_temp,limit=1,sort=nearest] ml_badge = #ml_text ml_badge
scoreboard players add #ml_text ml_badge 1
execute store result entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.bubble_id int 1 run scoreboard players get @e[tag=ml_dialogue_bubble,tag=ml_temp,limit=1,sort=nearest] ml_badge
execute if data entity @s CustomName run data modify entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.book.name set from entity @s CustomName
execute unless entity @s[tag=ml_dialogue_init] run data modify entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.book set from entity @a[tag=ml_editing,limit=1,sort=nearest] SelectedItem.tag.book
data modify entity @e[tag=ml_dialogue_text,limit=1,sort=nearest] transformation.translation set value [0f,0.85f,0f]
data modify entity @e[tag=ml_dialogue_text,limit=1,sort=nearest] text set from entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.book.name
execute unless data entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] {data:{book:{name_visible:1b}}} as @e[tag=ml_dialogue_text,limit=1,sort=nearest] run function ml_dialogue:logic/misc/text/reset
execute as @e[tag=ml_dialogue_bubble,tag=ml_temp,limit=1,sort=nearest] on passengers run data modify entity @s see_through set from entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.book.bubble_see_through

data modify entity @s PersistenceRequired set value 1b
execute store result entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.had_no_ai byte 1 run data get entity @s NoAI
execute store result entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.was_invulnerable byte 1 run data get entity @s Invulnerable
data modify entity @s Invulnerable set value 1b
execute if data entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] {data:{book:{no_ai:1b}}} run data modify entity @s NoAI set value 1b
execute store result entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.was_silent byte 1 run data get entity @s Silent
data modify entity @s Silent set from entity @e[tag=ml_dialogue_data,limit=1,sort=nearest] data.book.use_sound

execute unless entity @s[tag=ml_dialogue_init] run data modify storage ml_dialogue:text data.system.advanced set value '[{"text":"Dialogue data has been set for "},{"entity":"@e[tag=ml_dialogue_data,tag=ml_temp,limit=1,sort=nearest]","nbt":"data.book.name","interpret":true}]'
execute unless entity @s[tag=ml_dialogue_init] as @a[tag=ml_editing,limit=1,sort=nearest] run function ml_dialogue:text/system/advanced
execute as @e[tag=ml_temp] run ride @s mount @e[tag=ml_temp_dialogue,limit=1]
execute as @e[tag=ml_temp_dialogue,limit=1] run function ml_dialogue:logic/dialogue/create/entity/width_check
execute as @a[tag=ml_editing,nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{CustomModelData:101}}},limit=1,sort=nearest] run item replace entity @s weapon with minecraft:air
tag @a remove ml_editing
tag @e remove ml_temp
tag @s remove ml_temp_dialogue
tag @s add ml_interact_update
schedule function ml_dialogue:logic/dialogue/edit/interact_update 3t