tag @s remove ml_choice_menu
tag @s remove ml_choice_jump_menu
tag @s add ml_line_menu
function ml_dialogue:logic/dialogue/create/editor_data
function ml_dialogue:text/clear
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.response run data modify storage ml_dialogue:text data.npc.line set value '{"text":"(No Player Response Set)","color":"gold"}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.response run data modify storage ml_dialogue:text data.npc.line set from entity @e[tag=ml_badge_entity,limit=1] data.editor_line.response
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.function run data modify storage ml_dialogue:text data.dialogue.menu.line_function set value '{"text":"(No Line Command Set)","color":"gold"}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.function run data modify storage ml_dialogue:text data.dialogue.menu.line_function set value '{"entity":"@e[tag=ml_badge_entity,limit=1]","nbt":"data.editor_line.function","color":"dark_green"}'
tellraw @s [{"text":"---- [","color":"#C29C54"},{"entity":"@e[tag=ml_badge_entity,limit=1]","nbt":"data.book.name","interpret":true},{"text":"] Line Editor ----\n\n"},{"text":"  [Edit Player Response] ","color":"yellow","hoverEvent":{"action":"show_text","contents":"Edit the player response text for this line"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/lines/edit_response"}},{"text":": "},{"storage":"ml_dialogue:text","nbt":"data.npc.line_display","interpret":true},{"text":"\n\n"},{"text":"  [Edit Line Command] ","color":"green","hoverEvent":{"action":"show_text","contents":"Edit the command code that runs when this line is displayed"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/lines/edit_function"}},{"text":": "},{"storage":"ml_dialogue:text","nbt":"data.dialogue.menu.line_function","interpret":true}]
data modify storage ml_dialogue:text data.npc.line set from entity @e[tag=ml_badge_entity,limit=1] data.editor_line.line
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.choices[0] run data modify storage ml_dialogue:text data.dialogue.menu.choices set value '{"text":" [Set Choices] ","color":"dark_aqua","hoverEvent":{"action":"show_text","contents":"Set the choices that the player can choose from when this line is displayed"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/choices/choices"}}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_line.choices[0] run data modify storage ml_dialogue:text data.dialogue.menu.choices set value '{"text":" [Edit Choices] ","color":"dark_aqua","hoverEvent":{"action":"show_text","contents":"Edit the choices that the player can choose from when this line is displayed"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/choices/choices"}}'
tellraw @s [{"text":"\n----------------------------\n\n","color":"#C29C54"},{"text":" Line Text: "},{"storage":"ml_dialogue:text","nbt":"data.npc.line_display","interpret":true},{"text":"\n\n"},{"text":"  [Edit Line Text] ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Edit this line's text"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/lines/edit_line"}},{"text":"  |  "},{"text":" [Delete Line] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Delete this line"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/line_edit_delete"}},{"text":"\n\n----------------------------\n\n"},{"storage":"ml_dialogue:text","nbt":"data.dialogue.menu.choices","interpret":true},{"text":"  |  "},{"text":" [Back] ","color":"red","hoverEvent":{"action":"show_text","contents":"Return to the Lines Editor Menu"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/lines"}},{"text":"  |  "},{"text":" [Main Menu] ","color":"red","hoverEvent":{"action":"show_text","contents":"Return to the Main Menu"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/main"}},{"text":"\n"}]
function ml_dialogue:logic/dialogue/create/editor_data_final