tag @s remove ml_choice_jump_menu
function ml_dialogue:logic/dialogue/create/editor_data
function ml_dialogue:text/clear
execute if data storage ml_dialogue:text data.system.menu_notice run function ml_dialogue:text/blank
execute if data storage ml_dialogue:text data.system.menu_notice run tellraw @s [{"text":"[","color":"#C29C54"},{"storage":"ml_dialogue:text","nbt":"data.system.menu_notice","interpret":true},{"text":"]"}]
execute if data storage ml_dialogue:text data.system.menu_notice run function ml_dialogue:text/blank
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.response run data modify storage ml_dialogue:text data.npc.line set value '{"text":"(No NPC Response Set)","color":"gold"}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.response run data modify storage ml_dialogue:text data.npc.line set from entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.response
tellraw @s [{"text":"---- [","color":"#C29C54"},{"entity":"@e[tag=ml_badge_entity,limit=1]","nbt":"data.book.name","interpret":true},{"text":"] Choice Editor ----\n\n"},{"text":"  [Edit NPC Response] ","color":"yellow","hoverEvent":{"action":"show_text","contents":"Edit the NPC response text that displays when this choice is selected"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/choices/edit_response"}},{"text":": "},{"storage":"ml_dialogue:text","nbt":"data.npc.line_display","interpret":true}]
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.function run data modify storage ml_dialogue:text data.dialogue.menu.line_function set value '{"text":"(No Choice Command Set)","color":"gold"}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.function run data modify storage ml_dialogue:text data.dialogue.menu.line_function set value '{"entity":"@e[tag=ml_badge_entity,limit=1]","nbt":"data.editor_choice.function","color":"dark_green"}'
execute unless data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.jump_to run data modify storage ml_dialogue:text data.npc.line set value '{"text":"(No Line Jump Set)","color":"gold"}'
execute if data entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.jump_to run function ml_dialogue:logic/dialogue/create/menu/choices/get_jump_line
tellraw @s [{"text":"\n","color":"#C29C54"},{"text":"  [Edit Choice Command] ","color":"green","hoverEvent":{"action":"show_text","contents":"Edit the command code that runs when this choice is selected"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/choices/edit_function"}},{"text":": "},{"storage":"ml_dialogue:text","nbt":"data.dialogue.menu.line_function","interpret":true},{"text":"\n\n "},{"text":" [Set Line Jump] ","color":"#bfa1f1","hoverEvent":{"action":"show_text","contents":"Set the line that this choice will jump to after it's been selected"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/choices/jump_list"}},{"text":": "},{"storage":"ml_dialogue:text","nbt":"data.npc.line_display","interpret":true}]
data modify storage ml_dialogue:text data.npc.line set from entity @e[tag=ml_badge_entity,limit=1] data.editor_choice.line
tellraw @s [{"text":"\n----------------------------\n\n","color":"#C29C54"},{"text":" Choice Text: "},{"storage":"ml_dialogue:text","nbt":"data.npc.line_display","interpret":true},{"text":"\n\n"},{"text":"  [Edit Choice Text] ","color":"aqua","hoverEvent":{"action":"show_text","contents":"Edit this choice's text"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/choices/edit_choice"}},{"text":"  |  "},{"text":" [Delete Choice] ","color":"#DD743B","hoverEvent":{"action":"show_text","contents":"Delete this choice"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/choices/edit_delete"}},{"text":"\n\n----------------------------\n\n"},{"text":" [Back] ","color":"red","hoverEvent":{"action":"show_text","contents":"Return to the Choice Editor Menu"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/choices/choices"}},{"text":"  |  "},{"text":" [Main Menu] ","color":"red","hoverEvent":{"action":"show_text","contents":"Return to the Main Menu"},"clickEvent":{"action":"run_command","value":"/function ml_dialogue:logic/dialogue/create/menu/main"}},{"text":"\n"}]
function ml_dialogue:logic/dialogue/create/editor_data_final
data remove storage ml_dialogue:text data.system.menu_notice